#ifndef BASE_H
#define BASE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>

#if defined (__WATCOMC__)
#  pragma inline_depth     (255);
#  pragma inline_recursion (off);
#endif

#define FALSE  0
#define TRUE   1
#define OFF    0
#define ON     1
#define NO     0
#define YES    1

#define TEXT_SIZE 1024

/*
typedef enum boolean {
   FALSE = 0,
   TRUE  = -1
} bool_t;
*/

typedef unsigned long   u32;        /* Portable structure reading */
typedef   signed long   s32;        /* Eg : Picture files         */
typedef unsigned short  u16;
typedef   signed short  s16;
typedef unsigned char   u8;
typedef   signed char   s8;
typedef unsigned char   u1;
typedef   signed char   s1;

#ifndef __GNUC__
typedef unsigned short   bool;
#endif

typedef unsigned char    byte;      /* Personal preference */
typedef unsigned char   ubyte;
typedef   signed char   sbyte;
typedef unsigned short   word;
typedef unsigned short  uword;
typedef   signed short  sword;
typedef unsigned long   dword;
typedef unsigned long  udword;
typedef   signed long  sdword;

typedef   char    ascii_t;          /* Ascii value                */
typedef   byte    scode_t;          /* Scancode value             */
typedef sdword    index_t;          /* Array or file index        */
typedef    int    error_t;          /* Returned error value       */
typedef   void  (*void_function_t)(void);
                                    /* Pointers on function (void)*/

#if defined (__GNUC__)
#  define C_CALL
#  define INTERRUPT
#  define FAR
#endif
#if defined (__WATCOMC__)
#  define C_CALL     cdecl
#  define INTERRUPT  __interrupt __far
#  define FAR        __far
#endif

#if defined (__WATCOMC__)
#  define  CPPARGS
#else
#  if defined (__cplusplus)
#    define CPPARGS ...
#  else
#    define CPPARGS
#  endif
#endif

#ifndef START_EXTERN_C
#  ifdef __cplusplus
#     define START_EXTERN_C   extern "C"  {
#     define END_EXTERN_C                 }
#  else
#     define START_EXTERN_C
#     define END_EXTERN_C
#  endif
#endif

#include "debug.h"

#endif /* BASE_H */
