#include <signal.h>

#include "main.cc"
#include "ftp.h"
#include "ftpc.h"

Ftpc* clientFtp;

void signal_int (int signal_number)
{
  clientFtp->outputString("\nCtrl^C pressed. deconnection.\n");
  clientFtp->deconnection(); // For UDP unlucky case
  delete clientFtp;
  exit(0);
}

int Main::run(int argc, char** argv)
{
  try
	{
	  if(argc > 2)
		clientFtp = new Ftpc (argv[1],atoi(argv[2]));
	  else if(argc > 1)
		clientFtp = new Ftpc (argv[1],PORT);
	  else
		clientFtp = new Ftpc (HOST,PORT); 
	}
  catch(...)
	{
	  printf("Usage : %s <host name> <port>\n",argv[0]);
	  return 0;
	}

  try
	{
	  signal(SIGINT,signal_int); // Catch Ctrl^C
	
	  printf("Ftp-Like Client on %s using protocole %s on port %d\n",
			 clientFtp->getLocalHostName(),
			 clientFtp->getProtocoleName(),
			 clientFtp->getPort());
	  //clientFtp->setVerbose(TRUE);

	  clientFtp->run();
	}
  catch(EMemoryException)
	{
	  clientFtp->outputString("We runned out off memory. aborting");
	  clientFtp->writeCommand("3 DECN Runned out off memory");
	  clientFtp->readCommand();
	}


  delete clientFtp;
  return 0;
}
