#ifndef CLASS_FTP
#define CLASS_FTP

#define USE_UDP
//#undef  USE_UDP

#define PORT       1664
#define HOST       "localhost"

#define BUFFERSIZE 1024

#include "socketTCP.h"
#include "socketUDP.h"
#include "inout.h"

#ifdef USE_UDP
class Ftp : public InOut , public SocketUDP
#else
class Ftp : public InOut , public SocketTCP
#endif
{
 private:
  typedef enum
	{
	  OrderExecuted = 0,  // No error
	  OrderUnknown  = 1,  // Unknown order used
	  OrderInvalid  = 2,  // Argument are invalid for order
	  OrderFailed   = 3,  // Failed trying executing order
	  OrderWaited   = 4,  // Order sequence waiting for new one
	  OrderFatal    = 5   // Protocol violation
	}
  order_t;
 
  char* ValidOrder; // List of the known valid order
  char* Order;      // A copy of the order of the received messy
  char* Data;       // A copy of the data part of the received messy

 public:

  Ftp (int bufferSize = BUFFERSIZE);
  ~Ftp ();

  bool isOrder(const char* string);

  unsigned int headerSize   ();
  int          getErrorCode (const char* string);
  const char*  getOrder     (const char* string);
  const char*  getData      (const char* string);

  const char*  readCommand  (bool onErrorReRead=TRUE);
  ssize_t      writeCommand (const char* string, ...);
};

#endif
