#include <new.h>
#include <stdlib.h>
#include <string>

#include "main.h"

// Version Number

#define VERSION_CLASS_MAJOR_NUMBER   (0)
#define VERSION_CLASS_MINOR_NUMBER   (5)

#define VERSION_CLASS_MAJOR_LETTER  ('0'+ VERSION_CLASS_MAJOR_NUMBER)
#define VERSION_CLASS_MINOR_LETTER  ('0'+ VERSION_CLASS_MINOR_NUMBER)

// Defined static in Main.h
bool              Main::IsError;           // An error occur during execution
FILE*             Main::Stream;            // Stream used for print message
void_function_t   Main::ExitFunction;      // Function called at exit
void_function_t   Main::ErrorFunction;     // Function called when error
bool              Main::ErrorReport;       // Print the error message

// C Called function

void new_errror_handler (void)
{
#if defined __MSDOS__
  callDebugger();
#endif
  throw MemoryException(NULL);
}


// Start of application

int main (int argc, char** argv)
{
  Main Main;
  return Main.start(argc,argv);  
}


// Main function

Main::
Main ()
{
  IsError = FALSE;
  set_new_handler (new_errror_handler);

  main_exit_function(NULL);
  main_error_function(NULL);
  main_error_report(TRUE);

  //save_mode();
  header();

  set_print_log(NULL,stderr);
};


Main::
~Main()
{
  //restore_mode();
  if(ExitFunction != NULL && !IsError)
    ExitFunction();
}


char* Main::
version_string ()
{
  static char version[10];

  version[0] = VERSION_CLASS_MAJOR_LETTER;
  version[1] = '.';
  version[2] = VERSION_CLASS_MINOR_LETTER;
  version[3] = '\0';

  return version;
}

word  Main::
vesion_major()
{
  return VERSION_CLASS_MAJOR_NUMBER;
}

word  Main::
vesion_minor()
{
  return VERSION_CLASS_MINOR_NUMBER;
}


void Main::
header ()
{
  char*    Param;

  char* SlhanEnv;

  bool  Header;
  bool  Info;

#ifdef __MSDOS__

  Param = strlwr(getenv("CMDLINE"));
  SlhanEnv = strlwr(getenv("Slhan"));

#else

  // Under linux use /proc 
  Param = getenv("CMDLINE");
  SlhanEnv = getenv("Slhan");

#endif
  
  if(Param)
	{
	  Info   = (strstr(Param,"/class=info") != NULL);
	  Info  |= (strstr(Param,"--class=info") != NULL);
	}
  else
	Info = FALSE;

  if(SlhanEnv)
	Header = (strstr(SlhanEnv,"header") != NULL);
  else
	Header = FALSE;

  if(Header)
  {
	printf("---------------------------------------------------------------------\n");
    printf("Slhan's C++ Classes Application                           Version %s\n",version_string());
    printf("Copyright (C) 1997                              Slhan / Thomas Mangin\n");
	printf("---------------------------------------------------------------------\n");
  }

  if(Info)
  {
    printf("\n");
	printf("---------------------------------------------------------------------\n");
    printf("Compilation date [%s] time [%s]\n",__DATE__,__TIME__);
    printf("Component check function not available yet.\n");
	printf("---------------------------------------------------------------------\n");
    exit(0);
  }
}


int Main::
start (int argc, char** argv)
{
  try
  {
    return run(argc,argv);
  }
  catch(EError E)
  {
	IsError = TRUE;
    main_error_print(E.getMessage(),E.getFile(),E.getLine());
    return 0;
  }
  catch(EException E)
  {
    main_error_print(E.getMessage(),E.getFile(),E.getLine());
    return 0;
  }
  catch(...)
  {
    main_error_print("Programmers : You are not catching all your exceptions","Unknow",0);
    return 0;
  }
}

void main_error_report (bool state)
{
  Main::ErrorReport = state;
}

void main_error_function (void_function_t function)
{
  Main::ErrorFunction = function;
}

void main_exit_function (void_function_t function)
{
  Main::ExitFunction = function;
}

void main_error_print (const char* text, const char* file, int line)
{
  //restore_mode ();

  if(Main::ErrorFunction != NULL)
    Main::ErrorFunction();

  if(Main::ErrorReport)
	print_log(text,file,line);
}

#include "print.inl"
