#ifndef CLASS_MAIN
#define CLASS_MAIN

#include "base.h"

class Main
{
   private:
      static bool              IsError;          // An error occur during execution
      static FILE*             Stream;           // Stream used for print message
      static void_function_t   ExitFunction;     // Function called at exit
      static void_function_t   ErrorFunction;    // Function called when error
      static bool              ErrorReport;      // Print the error message

      int   start     (int argc, char** argv);
      void  header    ();

      friend int main (int argc, char** argv);

   public:
       Main ();
      ~Main ();

      char* version_string  ();
      word  vesion_major    ();
      word  vesion_minor    ();

      // User code
      int run (int argc, char** argv);

      // Are we printing the final error report
      friend void main_error_report (bool state);

      // Code called before error exiting
      friend void main_error_function (void_function_t function);

      // Code called after the video mode restoration
      friend void main_exit_function (void_function_t function);

      // exit and print text (error stream)
      friend void main_error_print (const char* text, const char* file, int line);
};

#endif
