#include "print.h"

char* FileName    = NULL;         // Name of the file associated
FILE* FileHandle  = stdout;       // Stream File associated

void set_print_log (const char *file_name, FILE * stream)
{
  if (FileHandle != stdout && FileHandle != stderr)
    fclose (FileHandle);

  if (stream == NULL || stream == stdin)
  {
    FileHandle = stderr;
  }
  else
  {
    if (file_name == NULL)
    {
      FileName   = NULL;
      FileHandle = stream;
    }
    else
    {
      delete FileName;
      FileName = new char[strlen(file_name)+1];
      strcpy(FileName,file_name);
      FileHandle = freopen (file_name, "w+", stream);
    }
  }

  if (ferror (FileHandle) != 0)
  {
    FileHandle = stderr;
  }
}


void print_log (const char* text, const char* file, int line)
{
  #ifdef NDEBUG
  #
      fprintf(FileHandle, "Application RunTime Error\n");
      fprintf(FileHandle, "%s\n", text);
      fflush(FileHandle);
  #
  #else
  #
    if (FileName == NULL)
    {
      fprintf (FileHandle, "\n"                        );
      fprintf (FileHandle, "File       : %s\n"  , file );
      fprintf (FileHandle, "Line       : %u\n"  , line );
      fprintf (FileHandle, "Message    : %s\n"  , text );
      fprintf (FileHandle, "\n"                        );
      fflush(FileHandle);
    }
    else
    {
      fprintf (FileHandle, "- File - %-25s " , file );
      fprintf (FileHandle, "- Line - %5u " , line   );
      fprintf (FileHandle, "- Messy - %s " , text   );
      fprintf (FileHandle, "\n"                     );
      fflush(FileHandle);
    }
  #
  #endif
}
