#include "main.cc"
#include "ftp.h"
#include "ftpd.h"

int Main::run(int argc, char** argv)
{
  Ftpd* serverFtp;
 
  try
	{
	  if(argc > 1)
		serverFtp = new Ftpd (atoi(argv[1]));
	  else
		serverFtp = new Ftpd (PORT);	  
	}
  catch(...)
	{
	  printf("Usage : %s <host name> <port>\n",argv[0]);
	  return 0;
	}

  try
	{
	  printf("Ftp-Like Server on %s using protocole %s on port %d\n",
			 serverFtp->getLocalHostName(),
			 serverFtp->getProtocoleName(),
			 serverFtp->getPort());
	  serverFtp->setVerbose(TRUE);
	  serverFtp->run();
	}
  catch(EMemoryException)
	{
	  serverFtp->outputString("We runned out off memory. aborting");
	  serverFtp->writeCommand("3 DECN Runned out off memory");
	  serverFtp->readCommand();
	}
  catch(ESocketException)
	{
	  serverFtp->outputString("Connection Closed\n");	  	 
	}

  delete serverFtp;
  return 0;
}
