#include <unistd.h>
#include <errno.h>

#include "socketTCP.h"


SocketTCP::SocketTCP(int bufferSize) : Socket(bufferSize)
{
  SocketStream = socket(AF_INET,TCP,0);
  
  if(!SocketStream)
	{
	  closeSocket();
	  throw SocketException("Can't create Socket");
	}
}


void SocketTCP::serverOn(port_t port)
{
  Socket::serverOn(port);
  if(listen(SocketStream,1))
	throw ListenException("Can't listen on socket");
}

void SocketTCP::accept ()
{
  unsigned int    size;
  struct sockaddr socketAddress;

  size = sizeof(socketAddress);
  AcceptStream = ::accept(SocketStream,&socketAddress,&size);
  
  if(AcceptStream<0)
	throw AcceptException("Can't accept client on socket");   
  
  RemoteHostInfo = gethostbyname(inet_ntoa(((struct sockaddr_in*)(&socketAddress))->sin_addr));
 
  if(!RemoteHostInfo)
	throw NoRouteToHostException("Unable to find client hostname information");
  
  IOStream = &AcceptStream;
}


char SocketTCP::readChar ()
{
  ssize_t number;
  char    car;

  number = ::read(getDescriptor(),&car,1);
  if (number != 1)
	throw SocketAccessException("Can't read on socket");

  return car;
}

void SocketTCP::writeChar(char car)
{
  ssize_t number;

  number = ::write(getDescriptor(),&car,1);
  if (number <= 0)
	throw SocketAccessException("Can't write on socket");
}



port_t SocketTCP::getPort()
{
  return SocketPort;  
}

protocole_t SocketTCP::getProtocole()
{
  return TCP;
}

const char* SocketTCP::getProtocoleName()
{
  return StringTCP;
}
