#ifndef INCLUDE_SOCKET_UDP
#define INCLUDE_SOCKET_UDP

#include "socket.h"

// The class

class SocketUDP : public Socket
{
 private:

  port_t AcceptPort;                  // UDP Client Communication port
  struct sockaddr_in AcceptInfo; // The Socket UDP server  

  char LastSended;    // Last message index sended
  char WaitingFor;      // Waiting message

  char SendBuffer[2]; // Sended Message to resend in case of error

  char nextValue(char value); //  next valid value for LastSended and WaitingFor
  void sendAck(bool ok);
  bool recvAck();

 public:
   SocketUDP(int bufferSize);
  ~SocketUDP();

  void clientOf (const char* hostname, port_t port);
  void accept();
  
  char readChar  ();
  void writeChar (char car);

  port_t      getPort ();
  protocole_t getProtocole ();
  const char* getProtocoleName ();
};


#endif
